#define NRANSI
#include "x_nrcpp.h"

using namespace XMeshLib_Nrcpp;

void XMeshLib_Nrcpp::preparesvbksb(xreal w[], int n)
{
	double wmax, wmin;
	wmax = 0;
	for (int i=0; i<n; ++i)
	{
		if (w[i] > wmax)
			wmax = w[i];
	}
	//wmin = wmax * 1e-6;
	wmin = wmax * 1e-4;
	for (int i=0; i<n; ++i)
	{
		if (w[i] < wmin)
			w[i] = 0;
	}
}

void XMeshLib_Nrcpp::svbksb(xreal **u, xreal w[], xreal **v, int m, int n, xreal b[], xreal x[])
{
	int jj,j,i;
	xreal s,*tmp;

	tmp=new xreal [n+1];//vector(1,n);
	for (j=0;j<n;++j) 
	{
		s=0.0;
		if (w[j]) 
		{
			for (i=0;i<m;++i) s += u[i][j]*b[i];
			s /= w[j];
		}
		tmp[j]=s;
	}
	for (j=0;j<n;++j) 
	{
		s=0.0;
		for (jj=0;jj<n;jj++) s += v[j][jj]*tmp[jj];
		x[j]=s;
	}
	delete [] tmp;//free_vector(tmp,1,n);
}

#undef NRANSI
