#include "x_nrcpp.h"

#define NRANSI

using namespace XMeshLib_Nrcpp;

//xreal XMeshLib_Nrcpp::pythag(xreal a, xreal b)
//{
//	xreal absa,absb;
//	absa=(xreal)fabs(a);
//	absb=(xreal)fabs(b);
//	if (absa > absb) return (xreal)(absa*sqrt(1.0+SQR(absb/absa)));
//	else return (xreal)(absb == 0.0 ? 0.0 : absb*sqrt(1.0+SQR(absa/absb)));
//}


void XMeshLib_Nrcpp::tqli(xreal d[], xreal e[], int n, xreal **z)
{
	int m,l,iter,i,k;
	xreal s,r,p,g,f,dd,c,b;

	for (i=2;i<=n;++i) e[i-1]=e[i];
	e[n]=0.0;
	for (l=1;l<=n;l++)
	{
		iter=0;
		do {
			for (m=l;m<=n-1;m++) {
				dd=(xreal)(fabs(d[m])+fabs(d[m+1]));
				if ((xreal)(fabs(e[m])+dd) == dd) break;
			}
			if (m != l) {
				if (iter++ == 30) exit(0);
				g=(d[l+1]-d[l])/((xreal)2.0*e[l]);
				r=pythag(g,1.0);
				g=(xreal)(d[m]-d[l]+e[l]/(g+SIGN(r,g)));
				s=c=1.0;
				p=0.0;
				for (i=m-1;i>=l;i--) {
					f=s*e[i];
					b=c*e[i];
					e[i+1]=(r=pythag(f,g));
					if (r == 0.0) {
						d[i+1] -= p;
						e[m]=0.0;
						break;
					}
					s=f/r;
					c=g/r;
					g=d[i+1]-p;
					r=(xreal)((d[i]-g)*s+2.0*c*b);
					d[i+1]=g+(p=s*r);
					g=c*r-b;
					for (k=1;k<=n;k++) {
						f=z[k][i+1];
						z[k][i+1]=s*z[k][i]+c*f;
						z[k][i]=c*z[k][i]-s*f;
					}
				}
				if (r == 0.0 && i >= l) continue;
				d[l] -= p;
				e[l]=g;
				e[m]=0.0;
			}
		} while (m != l);
	}
}

#undef NRANSI
